PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Static Protected Member Functions | List of all members
PHTTPAuthority Class Referenceabstract

This abstract class describes the authorisation mechanism for a Universal Resource Locator. More...

`#include <http.h>`

Inheritance diagram for PHTTPAuthority:
[legend]
Collaboration diagram for PHTTPAuthority:
[legend]

## Public Member Functions
virtual PString | GetRealm (const PHTTPRequest &request) const =0
| Get the realm or name space for the user authorisation name and password as required by the basic authorisation system of HTTP/1.0. More...
virtual PBoolean | Validate (const PHTTPRequest &request, const PString &authInfo) const =0
| Validate the user and password provided by the remote HTTP client for the realm specified by the class instance. More...
virtual PBoolean | IsActive () const
| Determine if the authorisation is to be applied. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Protected Member Functions
static void | DecodeBasicAuthority (const PString &authInfo, PString &username, PString &password)

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier
Friends inherited from PObject

## Detailed Description

This abstract class describes the authorisation mechanism for a Universal Resource Locator.

## Member Function Documentation

static void PHTTPAuthority::DecodeBasicAuthority | ( | const PString & | authInfo,
|  | PString & | username,
|  | PString & | password
| ) |  |
| static protected

Parameters

  authInfo | Authority information string.
  username | User name decoded from authInfo
  password | Password decoded from authInfo

virtual PString PHTTPAuthority::GetRealm | ( | const PHTTPRequest & | request | ) | const
| pure virtual

Get the realm or name space for the user authorisation name and password as required by the basic authorisation system of HTTP/1.0.

Returns
  String for the authorisation realm name.

Parameters

  request | Request information.

Implemented in PHTTPMultiSimpAuth, and PHTTPSimpleAuth.

virtual PBoolean PHTTPAuthority::IsActive | ( |  | ) | const
| virtual

Determine if the authorisation is to be applied.

This could be used to distinguish between net requiring authorisation and requiring autorisation but having no password.

The default behaviour is to return true.

Returns
  true if the authorisation in the realm is to be applied.

Reimplemented in PHTTPMultiSimpAuth, and PHTTPSimpleAuth.

virtual PBoolean PHTTPAuthority::Validate | ( | const PHTTPRequest & | request,
|  | const PString & | authInfo
| ) |  | const
| pure virtual

Validate the user and password provided by the remote HTTP client for the realm specified by the class instance.

Returns
  true if the user and password are authorised in the realm.

Parameters

  request | Request information.
  authInfo | Authority information string.

Implemented in PHTTPMultiSimpAuth, and PHTTPSimpleAuth.

The documentation for this class was generated from the following file:

- http.h